--- old/usr/src/tools/smatch/src/check_off_by_one_relative.c	Mon Aug  5 08:38:02 2019
+++ new/usr/src/tools/smatch/src/check_off_by_one_relative.c	Mon Aug  5 08:38:02 2019
@@ -33,6 +33,7 @@
 	struct expression *size;
 	struct expression *offset;
 	char *array_str, *offset_str;
+	int limit_type;
 
 	expr = strip_expr(expr);
 	if (!is_array(expr))
@@ -39,13 +40,16 @@
 		return;
 
 	array = get_array_base(expr);
-	size = get_size_variable(array);
-	if (!size)
+	size = get_size_variable(array, &limit_type);
+	if (!size || limit_type != ELEM_COUNT)
 		return;
 	offset = get_array_offset(expr);
 	if (!possible_comparison(size, SPECIAL_EQUAL, offset))
 		return;
 
+	if (buf_comparison_index_ok(expr))
+		return;
+
 	array_str = expr_to_str(array);
 	offset_str = expr_to_str(offset);
 	sm_warning("potentially one past the end of array '%s[%s]'", array_str, offset_str);
@@ -53,25 +57,6 @@
 	free_string(offset_str);
 }
 
-static int known_access_ok_comparison(struct expression *expr)
-{
-	struct expression *array;
-	struct expression *size;
-	struct expression *offset;
-	int comparison;
-
-	array = get_array_base(expr);
-	size = get_size_variable(array);
-	if (!size)
-		return 0;
-	offset = get_array_offset(expr);
-	comparison = get_comparison(size, offset);
-	if (comparison == '>' || comparison == SPECIAL_UNSIGNED_GT)
-		return 1;
-
-	return 0;
-}
-
 static int known_access_ok_numbers(struct expression *expr)
 {
 	struct expression *array;
@@ -108,7 +93,7 @@
 
 	if (known_access_ok_numbers(expr))
 		return;
-	if (known_access_ok_comparison(expr))
+	if (buf_comparison_index_ok(expr))
 		return;
 
 	array = get_array_base(expr);
